import java.util.Random;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.steema.teechart.ScrollMode;
import com.steema.teechart.TChart;
import com.steema.teechart.drawing.Color;
import com.steema.teechart.styles.FastLine;
import com.steema.teechart.styles.ValueListOrder;


public class Test {


    private TChart chart;
    private FastLine line;
    
    private double maxY=5d;
    private double minY=0d;
    
    private double maxX=20.0d;
    private double minX=0.0d;
    
    private double counter=0;
    
    private Runnable timer;

    public static void main(String [] args){

        final Display display = new Display();
        Shell shell = new Shell(display);
        shell.setLayout(new FillLayout());
        shell.setSize(600,800);
        

        
    
    new Test().createContent(display, shell);
    
    
    shell.open();
    while (!shell.isDisposed()) {
      if (!display.readAndDispatch()) {
        display.sleep();
      }
    }
    display.dispose();
    
    }



    private void createContent(final Display display, Shell shell) {
        chart = new TChart(shell, SWT.DOUBLE_BUFFERED);
        
        
        chart.getHeader().setVisible(false);
        chart.getLegend().setVisible(false);
        chart.getGraphics3D().getAspect().setView3D(false);
        chart.getFrame().setVisible(false);
        
        chart.setAutoRepaint(false);
        chart.getAxes().getBottom().getTitle().setText("X Axis value");
        chart.getAxes().getBottom().setMaximum(maxX);
        chart.getAxes().getBottom().setMinimum(minX);        
        chart.getAxes().getBottom().setAutomatic(true);
        chart.getAxes().getBottom().setAutomaticMaximum(true);
        chart.getAxes().getBottom().getAxisPen().setWidth(1);
        
        chart.getAxes().getBottom().setMaximumOffset(10);
//
//        chart.getPage().setMaxPointsPerPage(100);
//        chart.getPage().setAutoScale(true);
//        chart.getPage().setAutoScale(true);
//        
//        chart.getPage().setCurrent(3);
//        chart.getPage().setScaleLastPage(true);

        //To stop Scroll functionality
        chart.getPanning().setAllow(ScrollMode.HORIZONTAL);
        
        
//    chart.getPage().setAutoScale(true);
        chart.getAxes().getBottom().setIncrement(1.0);
//    chart.getAxes().getBottom().getMinorGrid().setVisible(true);
        chart.getAxes().getBottom().getGrid().setVisible(true);
        
        chart.getAxes().getLeft().getTitle().setText("Y Axis value");
        chart.getAxes().getLeft().setMaximum(maxY);
        chart.getAxes().getLeft().setMinimum(minY);
        chart.getAxes().getLeft().getAxisPen().setWidth(1);
        chart.getAxes().getLeft().setAutomatic(false);
        //chart.getAxes().getLeft().setIncrement(1.0);
        chart.getAxes().getLeft().getGrid().setVisible(true);
//    chart.getAxes().getLeft().getMinorGrid().setVisible(true);
        
        chart.getPanel().setMarginBottom(1);
        chart.getPanel().setMarginTop(11);
        
        line = new FastLine(chart.getChart());
        line.setDrawAllPoints(false);
        line.getLinePen().setWidth(1);
        
        line.setStairs(false);
        line.getMarks().setVisible(false);
        line.setColor(Color.BLUE);
//    line.setTitle("Mass");
        line.setAutoRepaint(true);
        line.getXValues().setOrder(ValueListOrder.NONE);
        
        chart.setVisible(true);
        
        chart.refreshControl();
        chart.layout();
        chart.addControlListener(new ControlAdapter() {
                    @Override
                    public void controlResized(ControlEvent e) {
                        chart.refreshControl();
                    }
        });
        
//    chart.addPaintListener(new PaintListener(){
//        int cc;
//        @Override public void paintControl(PaintEvent e) {
//            System.out.println(cc++);
//        }
//    });
   
        final Random rand = new Random();
        Runnable timer1 = new Runnable() {
            public void run() {
                counter+=0.3;
                display.timerExec(300, this);
            }
        };
        

        Runnable timer2 = new Runnable() {
            private double hint=10.0;
            public void run() {
//            System.out.println(counter + " " + y);
                display.asyncExec(new Runnable() {
                    
                    @Override
                    public void run() {
                        double y = rand.nextInt((int) maxY);

                        addPoint(counter, y);

                        
                        double diff = maxX - minX;
                        if(counter > hint){
                           
                          chart.getAxes().getBottom().scroll(0.333, false);
                          hint+=0.333;
                            
                        }
                        chart.setAutoRepaint(true);
//                        chart.refreshControl();
//                        chart.redraw();
                        line.repaint();
                        chart.setAutoRepaint(false);
                    }
                });
                display.timerExec(300, this);
            }
        };

        final int time = 30;
        
        timer = new Runnable() {
          private double hint=10.0;

        public void run() {

            display.asyncExec(new Runnable() {
                
                @Override
                public void run() {
//                    double y = rand.nextInt((int) maxY);
//
//                    
//                    double diff = maxX - minX;
//                    if(counter > hint){
//                       
//                      chart.getAxes().getBottom().scroll(0.333, false);
//                      hint+=0.333;
//                        
//                    }
                    
                }
            });
           

            display.timerExec(time, this);
          }
        };
        
        Runnable actualtimer = new Runnable() {
            public void run() {
//            removeFinishedPoints();
                display.timerExec(1000, this);
            }
        };
        display.timerExec(300, timer1);
        display.timerExec(300, timer2);
        display.timerExec(time, timer);
        display.timerExec(1000, actualtimer);
    }
    
    
    public void initPaging(int maxPoints)
    {

    }     
 
private void addPoint(double x, double y){
    line.add(x,y);
}

private void changeXAxisBounds(){
    
    chart.getAxes().getBottom().setMaximum(maxX);
    chart.getAxes().getBottom().setMinimum(minX);        
}
/**
 * Passing the focus request to the viewer's control.
 */
public void setFocus() {
}



}
